LeetCode:Two Sum (JAVA)

LeetCode:Two Sum (JAVA)

Table of contents

No heading

No headings in the article.

Given an array of integers nums and an integer target, return indices of the two numbers such that they add up to the target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

You can return the answer in any order.

Example 1:

Input: nums = [2,7,11,15], target = 9 Output: [0,1] Explanation: Because nums[0] + nums[1] == 9, we return [0, 1].

Example 2:

Input: nums = [3,2,4], target = 6 Output: [1,2]

Example 3:

Input: nums = [3,3], target = 6 Output: [0,1]

Constraints:

2 <= nums.length <= 104
-109 <= nums[i] <= 109
-109 <= target <= 109
Only one valid answer exists.

Follow-up: Can you come up with an algorithm that is less than O(n2) time complexity?

Method one: Use Two for Loops(BruteForce) The naive approach is to just use two nested for loops and check if the sum of any two elements in the array is equal to the given target. Time complexity: O(n^2)

class Solution {
 public  int[] twoSum(int[] nums, int target) {
        for (int i = 0; i < nums.length; i++) {
            for (int j = i + 1; j < nums.length; j++) {
                if (nums[i] + nums[j] == target) {
                    return new int[] { i, j };
                }
            }
        }
        return new int[] {};
    }
  }

Method Two: Use a HashMap (Most efficient than the first) Time complexity: O(n)

class Solution {
    public int[] twoSum(int[] nums, int target) {
        Map<Integer, Integer> numsMap = new HashMap<>();
          for(int i=0; i<nums.length; i++){
              int result = target - nums[i];
                  if(numsMap.containsKey(result)){
                      return new int[]{numsMap.get(result), i};
                  }else{
                      numsMap.put(nums[i], i);
                  }
          }
         return new int[] {};
    }
}